Index: /branches/2.2/filemanager/inc/class.uifilemanager.inc.php
===================================================================
--- /branches/2.2/filemanager/inc/class.uifilemanager.inc.php	(revision 3610)
+++ /branches/2.2/filemanager/inc/class.uifilemanager.inc.php	(revision 3638)
@@ -455,570 +473,555 @@
 				$GLOBALS['phpgw']->common->phpgw_exit();
 			}
-
-			$this->bo->userinfo['working_id'] = $this->bo->vfs->working_id;
-			$this->bo->userinfo['working_lid'] = $GLOBALS['phpgw']->accounts->id2name($this->bo->userinfo['working_id']);
-
-			# Verify path is real
-			if($this->path != $this->bo->homedir && $this->path != '/' && $this->path != $this->bo->fakebase)
-			{
-				if(!$this->bo->vfs->file_exists(array(
-					'string' => $this->path,
-					'relatives' => array(RELATIVE_NONE)
-				)))
+		}
+
+
+		# Default is to sort by name
+		if(!$this->sortby)
+		{
+			$this->sortby = 'name';
+		}
+		if($this->update_x == 1){
+			$this->bo->vfs->update_real(array(
+				'string'        => $this->path,
+				'relatives'     => array(RELATIVE_NONE)
+			));
+			header('Location:'.$this->encode_href('index.php?menuaction=filemanager.uifilemanager.index','&path='.base64_encode($this->bo->homedir)));
+		}
+		elseif($this->newfile_x && $this->newfile_or_dir) // create new textfile
+		{
+			$this->createfile();
+		}
+		elseif($this->edit_cancel_x)
+		{
+			$this->readFilesInfo();
+			$this->fileListing();
+		}
+		elseif($this->edit_x || $this->edit_preview_x || $this->edit_save_x || $this->edit_save_done_x)
+		{
+			$this->edit();
+		}
+		else
+		{
+			//$this->readFilesInfo();
+			$this->fileListing();
+		}
+	}
+	function get_permissions(){
+		/* get permissions */
+		if((preg_match('+^'.$this->bo->fakebase.'\/(.*)(\/|$)+U', $this->path, $matches)) && $matches[1] != $this->bo->userinfo['account_lid']) //FIXME matches not defined
+
+		{
+			$this->bo->vfs->working_id = $GLOBALS['phpgw']->accounts->name2id($matches[1]);//FIXME matches not defined
+
+		}
+		else
+		{
+			$this->bo->vfs->working_id = $this->bo->userinfo['username'];
+		}
+
+		# Check available permissions for $this->path, so we can disable unusable operations in user interface
+		$path = explode('/',$this->path);
+		$owner_id = $this->bo->vfs->ownerOf($this->bo->fakebase,$path[2]);
+		$user_id = $GLOBALS['phpgw_info']['user']['account_id'];
+		if ($owner_id == $user_id)
+		{
+			$rights = 31;
+		}else
+		{
+			$acl = CreateObject ('phpgwapi.acl', $owner_id);
+			$acl->account_id = $owner_id;
+			$acl->read_repository();
+			$rights = $acl->get_rights($user_id);
+		}
+		return $rights;	
+	}
+	function dir_ls()
+	{
+		// change dir to this->path
+		$this->bo->vfs->cd(array('string' => $this->path, 'relatives' => array(RELATIVE_NONE), 'relative' => False));
+		$return['permissions'] = $this->get_permissions();
+		$return['quota']['usedSpace'] = $this->bo->vfs->get_size(array(
+				'string'        => $this->path,
+				'relatives'     => array(RELATIVE_NONE)
+		));
+		$return['files_count'] = $this->bo->vfs->count_files(array(
+				'string'        => $this->path,
+		));
+		$quota = $this->bo->vfs->get_quota(array(
+			'string'        => $this->path
+		));
+		reset($this->files_array);
+		$this->readFilesInfo();
+
+		for($i = 0; $i != $this->numoffiles; $i++)
+		{
+			$files = $this->files_array[$i];
+
+			if($files['mime_type'] == "Directory")
+			{
+				continue;
+			}
+			/* small keys to safe bandwidth */
+			$tuple['name'] = htmlentities($files['name']);
+			if ($_SESSION['phpgw_info']['user']['preferences']['filemanager']['viewIcons'] == 1){
+				if ($files['mime_type'] == 'image/png' || 
+					$files['mime_type'] == 'image/gif' || 
+					$files['mime_type'] == 'image/jpg')
 				{
-					$this->messages[] = lang('Error:').lang('Directory %1 does not exist', $this->path);
-					$this->path = $this->homedir;
-					$this->bo->vfs->cd(array('string' => $this->path, 'relatives' => array(RELATIVE_NONE), 'relative' => False));
-					$GLOBALS['phpgw']->common->phpgw_footer();
-					$GLOBALS['phpgw']->common->phpgw_exit();
+					$filename = str_replace('=','',base64_encode($tuple['name']));
+					$pathname = str_replace('=','',base64_encode($this->path));
+					$tuple['icon'] = './index.php?menuaction=filemanager.vfs_functions.summary&file='.$filename.'&path='.$pathname;
 				}
-			}
-
-
-			# Default is to sort by name
-			if(!$this->sortby)
-			{
-				$this->sortby = 'name';
-			}
-			if($this->update_x == 1){
-				$this->bo->vfs->update_real(array(
-					'string'        => $this->path,
-					'relatives'     => array(RELATIVE_NONE)
-				));
-				header('Location:'.$this->encode_href('index.php?menuaction=filemanager.uifilemanager.index','&path='.base64_encode($this->bo->homedir)));
-			}
-			elseif($this->newfile_x && $this->newfile_or_dir) // create new textfile
-			{
-				$this->createfile();
-			}
-			elseif($this->edit_cancel_x)
-			{
-				$this->readFilesInfo();
-				$this->fileListing();
-			}
-			elseif($this->edit_x || $this->edit_preview_x || $this->edit_save_x || $this->edit_save_done_x)
-			{
-				$this->edit();
+				else
+					$tuple['icon'] =  $this->mime_icon($files['mime_type'],64);
 			}
 			else
-			{
-				//$this->readFilesInfo();
-				$this->fileListing();
-			}
-		}
-		function get_permissions(){
-			/* get permissions */
-			if((preg_match('+^'.$this->bo->fakebase.'\/(.*)(\/|$)+U', $this->path, $matches)) && $matches[1] != $this->bo->userinfo['account_lid']) //FIXME matches not defined
-
-			{
-				$this->bo->vfs->working_id = $GLOBALS['phpgw']->accounts->name2id($matches[1]);//FIXME matches not defined
-
+				$tuple['icon'] = $this->mime_icon($files['mime_type']);
+			$tuple['type'] = $files['type'];
+			$tuple['created'] = $this->vfs_functions->dateString2timeStamp($files['created']);
+			$tuple['modified'] = $this->vfs_functions->dateString2timeStamp($files['modified']);
+			$tuple['size'] = $files['size'];
+			$tuple['mime_type'] = $files['mime_type'];
+			$tuple['pub'] = $files['type'];
+			$tuple['createdby_id'] = $GLOBALS['phpgw']->accounts->id2name($files['createdby_id']);
+			$tuple['modifiedby_id'] = $files['modifiedby_id']?$GLOBALS['phpgw']->accounts->id2name($files['modifiedby_id']):'';
+			$tuple['owner'] = $GLOBALS['phpgw']->accounts->id2name($files['owner_id']);
+			$tuple['comment'] = $files['comment'];
+			$tuple['version'] = $files['version'];
+			$output[] = $tuple;
+
+		}
+		$return['files'] = $output;
+		$return['quota']['quotaSize'] = ($quota*1024*1024);
+		echo serialize($return);
+	}
+	function get_folders_list()
+	{
+		$this->update_groups();	
+		$this->groups_applications = array();
+
+		$user_groups = $GLOBALS['phpgw']->accounts->membership();
+		foreach($user_groups as $val){
+			$account_name = $GLOBALS['phpgw']->accounts->id2name($val['account_id']);
+			$this->readable_groups[$account_name] = array(
+				'account_id' => $val['account_id'],
+				'account_name' => $account_name
+			);
+		}
+
+		foreach ($this->readable_groups as $value)
+		{
+			$applications = CreateObject('phpgwapi.applications', $value['account_id']);
+			$this->groups_applications[$value['account_name']] = $applications->read_account_specific();
+		}
+
+
+		// selectbox for change/move/and copy to
+		$this->dirs = $this->all_other_directories();
+		foreach($this->dirs as $dir)
+			$return[] = $dir['directory'] . $dir['name'];
+		sort(&$return, SORT_STRING);
+		echo serialize($return);
+	}
+	function fileListing()
+	{
+		$this->t->set_file(array('filemanager_list_t' => 'main.tpl'));
+		$this->t->set_block('filemanager_list_t','filemanager_header','filemanager_header');
+		$this->t->set_block('filemanager_list_t','filemanager_footer','filemanager_footer');
+
+		if($this->numoffiles || $this->cwd)
+		{
+			$vars[path]='<input type="hidden" id="currentPath" value="'.$this->path.'">';
+			$vars[css]='<link rel="stylesheet" type="text/css" href="filemanager/templates/default/main.css">';
+			$vars[css].='<link rel="stylesheet" type="text/css" href="phpgwapi/js/dftree/dftree.css">';
+			$_SESSION['phpgw_info']['user']['preferences']['filemanager']['lid'] = $GLOBALS['phpgw_info']['user']['account_lid'];
+			$vars[preferences]='<input type="hidden" id="userPreferences" value=\''.serialize($_SESSION['phpgw_info']['user']['preferences']['filemanager']).'\'>';
+			// Used for important operations that needs security
+			for ($key = ""; strlen($key) < 150; $key .= chr(rand(48,95)));
+			$_SESSION['phpgw_info']['filemanager']['user']['sec_key'] = $key;
+			$vars[sec_key]='<input type="hidden" id="userKey" value=\''.$key.'\'>';
+			$vars[script]='<script>initDrawApi();</script>';
+			
+			$vars[new_button]=$this->toolButton('new','createfile',lang('New...'));
+			$vars[new_button].='<input type="hidden" id="newfile_or_dir" name="newfile_or_dir" value="" />';
+			
+			// reload button with this url
+			$vars[refresh_button]=$this->toolButton('reload','reload',lang('reload'));
+
+			// go up icon when we're not at the top, dont allow to go outside /home = fakebase
+			if($this->path != '/' && $this->path != $this->bo->fakebase)
+			{
+				$vars[tools_button] = $this->toolButton('tools','tools',lang('tools'));
 			}
 			else
-			{
-				$this->bo->vfs->working_id = $this->bo->userinfo['username'];
-			}
-
-			# Check available permissions for $this->path, so we can disable unusable operations in user interface
-			$path = explode('/',$this->path);
-			$owner_id = $this->bo->vfs->ownerOf($this->bo->fakebase,$path[2]);
-			$user_id = $GLOBALS['phpgw_info']['user']['account_id'];
-			if ($owner_id == $user_id)
-			{
-				$rights = 31;
-			}else
-			{
-				$acl = CreateObject ('phpgwapi.acl', $owner_id);
-				$acl->account_id = $owner_id;
-				$acl->read_repository();
-				$rights = $acl->get_rights($user_id);
-			}
-			return $rights;	
-		}
-		function dir_ls()
-		{
-			// change dir to this->path
-			$this->bo->vfs->cd(array('string' => $this->path, 'relatives' => array(RELATIVE_NONE), 'relative' => False));
-			$return['permissions'] = $this->get_permissions();
-			$return['quota']['usedSpace'] = $this->bo->vfs->get_size(array(
-					'string'        => $this->path,
-					'relatives'     => array(RELATIVE_NONE)
+				$vars[tools_button] = "";
+
+			$vars[toolbar1]=$toolbar;
+
+			if(count($this->messages)>0) 
+			{
+				foreach($this->messages as $msg)
+				{
+					$messages.='<span>'.$msg.'</span>';
+				}
+			}
+			$this->messages = NULL;
+			
+			$vars[messages]=$messages;
+
+			$this->t->set_var($vars);
+			$this->t->pparse('out','filemanager_header');
+		}
+
+		$this->t->set_var($vars);
+		$this->t->pparse('out','filemanager_footer');
+
+		$GLOBALS['phpgw']->common->phpgw_footer();
+		$GLOBALS['phpgw']->common->phpgw_exit();
+	}
+
+	function readFilesInfo()
+	{
+		// start files info
+
+		# Read in file info from database to use in the rest of the script
+		# $fakebase is a special directory.  In that directory, we list the user's
+		# home directory and the directories for the groups they're in
+		$this->numoffiles = 0;
+		if($this->path == $this->bo->fakebase)
+		{
+			// FIXME this test can be removed
+			if(!$this->bo->vfs->file_exists(array('string' => $this->bo->homedir, 'relatives' => array(RELATIVE_NONE))))
+			{
+				$this->bo->vfs->mkdir(array('string' => $this->bo->homedir, 'relatives' => array(RELATIVE_NONE)));
+			}
+
+			$ls_array = $this->bo->vfs->ls(array(
+				'string' => $this->bo->homedir,
+				'relatives' => array(RELATIVE_NONE),
+				'checksubdirs' => False,
+				'nofiles' => True
 			));
-			$return['files_count'] = $this->bo->vfs->count_files(array(
-					'string'        => $this->path,
-			));
-			$quota = $this->bo->vfs->get_quota(array(
-				'string'        => $this->path
-			));
-			reset($this->files_array);
-			$this->readFilesInfo();
-
-			for($i = 0; $i != $this->numoffiles; $i++)
-			{
-				$files = $this->files_array[$i];
-
-				if($files['mime_type'] == "Directory")
+
+			$this->files_array[] = $ls_array[0];
+			$this->numoffiles++;
+
+			reset($this->readable_groups);
+			while(list($num, $group_array) = each($this->readable_groups))
+			{
+				# If the group doesn't have access to this app, we don't show it
+				/*if(!$this->groups_applications[$group_array['account_name']][$this->bo->appname]['enabled'])
 				{
 					continue;
 				}
-				/* small keys to safe bandwidth */
-				$tuple['name'] = htmlentities($files['name']);
-				if ($_SESSION['phpgw_info']['user']['preferences']['filemanager']['viewIcons'] == 1){
-					if ($files['mime_type'] == 'image/png' || 
-						$files['mime_type'] == 'image/gif' || 
-						$files['mime_type'] == 'image/jpg')
-					{
-						$filename = str_replace('=','',base64_encode($tuple['name']));
-						$pathname = str_replace('=','',base64_encode($this->path));
-						$tuple['icon'] = './index.php?menuaction=filemanager.vfs_functions.summary&file='.$filename.'&path='.$pathname;
-					}
-					else
-						$tuple['icon'] =  $this->mime_icon($files['mime_type'],64);
+				*/
+
+
+				if(!$this->bo->vfs->file_exists(array('string' => $this->bo->fakebase.'/'.$group_array['account_name'],'relatives'	=> array(RELATIVE_NONE))))
+				{
+					$this->bo->vfs->override_acl = 1;
+					$this->bo->vfs->mkdir(array(
+						'string' => $this->bo->fakebase.'/'.$group_array['account_name'],
+						'relatives' => array(RELATIVE_NONE)
+					));
+
+					// FIXME we just created a fresh group dir so we know there nothing in it so we have to remove all existing content
+					
+					
+					$this->bo->vfs->override_acl = 0;
+
+					$this->bo->vfs->set_attributes(array('string' => $this->bo->fakebase.'/'.$group_array['account_name'],'relatives'	=> array(RELATIVE_NONE),'attributes' => array('owner_id' => $group_array['account_id'],'createdby_id' => $group_array['account_id'])));
 				}
-				else
-					$tuple['icon'] = $this->mime_icon($files['mime_type']);
-				$tuple['type'] = $files['type'];
-				$tuple['created'] = $this->vfs_functions->dateString2timeStamp($files['created']);
-				$tuple['modified'] = $this->vfs_functions->dateString2timeStamp($files['modified']);
-				$tuple['size'] = $files['size'];
-				$tuple['mime_type'] = $files['mime_type'];
-				$tuple['pub'] = $files['type'];
-				$tuple['createdby_id'] = $GLOBALS['phpgw']->accounts->id2name($files['createdby_id']);
-				$tuple['modifiedby_id'] = $files['modifiedby_id']?$GLOBALS['phpgw']->accounts->id2name($files['modifiedby_id']):'';
-				$tuple['owner'] = $GLOBALS['phpgw']->accounts->id2name($files['owner_id']);
-				$tuple['comment'] = $files['comment'];
-				$tuple['version'] = $files['version'];
-				$output[] = $tuple;
-
-			}
-			$return['files'] = $output;
-			$return['quota']['quotaSize'] = ($quota*1024*1024);
-			echo serialize($return);
-		}
-		function get_folders_list()
-		{
-			$this->update_groups();	
-			$this->groups_applications = array();
-
-			$user_groups = $GLOBALS['phpgw']->accounts->membership();
-			foreach($user_groups as $val){
-				$account_name = $GLOBALS['phpgw']->accounts->id2name($val['account_id']);
-				$this->readable_groups[$account_name] = array(
-					'account_id' => $val['account_id'],
-					'account_name' => $account_name
-				);
-			}
-
-			foreach ($this->readable_groups as $value)
-			{
-				$applications = CreateObject('phpgwapi.applications', $value['account_id']);
-				$this->groups_applications[$value['account_name']] = $applications->read_account_specific();
-			}
-
-
-			// selectbox for change/move/and copy to
-			$this->dirs = $this->all_other_directories();
-			foreach($this->dirs as $dir)
-				$return[] = $dir['directory'] . $dir['name'];
-			sort(&$return, SORT_STRING);
-			echo serialize($return);
-		}
-		function fileListing()
-		{
-			$this->t->set_file(array('filemanager_list_t' => 'main.tpl'));
-			$this->t->set_block('filemanager_list_t','filemanager_header','filemanager_header');
-			$this->t->set_block('filemanager_list_t','filemanager_footer','filemanager_footer');
-
-			if($this->numoffiles || $this->cwd)
-			{
-				$vars[path]='<input type="hidden" id="currentPath" value="'.$this->path.'">';
-				$vars[css]='<link rel="stylesheet" type="text/css" href="filemanager/templates/default/main.css">';
-				$vars[css].='<link rel="stylesheet" type="text/css" href="phpgwapi/js/dftree/dftree.css">';
-				$_SESSION['phpgw_info']['user']['preferences']['filemanager']['lid'] = $GLOBALS['phpgw_info']['user']['account_lid'];
-				$vars[preferences]='<input type="hidden" id="userPreferences" value=\''.serialize($_SESSION['phpgw_info']['user']['preferences']['filemanager']).'\'>';
-				// Used for important operations that needs security
-				for ($key = ""; strlen($key) < 150; $key .= chr(rand(48,95)));
-				$_SESSION['phpgw_info']['filemanager']['user']['sec_key'] = $key;
-				$vars[sec_key]='<input type="hidden" id="userKey" value=\''.$key.'\'>';
-				$vars[script]='<script>initDrawApi();</script>';
-				
-				$vars[new_button]=$this->toolButton('new','createfile',lang('New...'));
-				$vars[new_button].='<input type="hidden" id="newfile_or_dir" name="newfile_or_dir" value="" />';
-				
-				// reload button with this url
-				$vars[refresh_button]=$this->toolButton('reload','reload',lang('reload'));
-
-				// go up icon when we're not at the top, dont allow to go outside /home = fakebase
-				if($this->path != '/' && $this->path != $this->bo->fakebase)
-				{
-					$vars[tools_button] = $this->toolButton('tools','tools',lang('tools'));
-				}
-				else
-					$vars[tools_button] = "";
-
-				$vars[toolbar1]=$toolbar;
-
-				if(count($this->messages)>0) 
-				{
-					foreach($this->messages as $msg)
-					{
-						$messages.='<span>'.$msg.'</span>';
-					}
-				}
-				$this->messages = NULL;
-				
-				$vars[messages]=$messages;
-
-				$this->t->set_var($vars);
-				$this->t->pparse('out','filemanager_header');
-			}
-
-			$this->t->set_var($vars);
-			$this->t->pparse('out','filemanager_footer');
-
-			$GLOBALS['phpgw']->common->phpgw_footer();
-			$GLOBALS['phpgw']->common->phpgw_exit();
-		}
-
-		function readFilesInfo()
-		{
-			// start files info
-
-			# Read in file info from database to use in the rest of the script
-			# $fakebase is a special directory.  In that directory, we list the user's
-			# home directory and the directories for the groups they're in
-			$this->numoffiles = 0;
-			if($this->path == $this->bo->fakebase)
-			{
-				// FIXME this test can be removed
-				if(!$this->bo->vfs->file_exists(array('string' => $this->bo->homedir, 'relatives' => array(RELATIVE_NONE))))
-				{
-					$this->bo->vfs->mkdir(array('string' => $this->bo->homedir, 'relatives' => array(RELATIVE_NONE)));
-				}
-
-				$ls_array = $this->bo->vfs->ls(array(
-					'string' => $this->bo->homedir,
-					'relatives' => array(RELATIVE_NONE),
-					'checksubdirs' => False,
-					'nofiles' => True
-				));
+
+				$ls_array = $this->bo->vfs->ls(array('string' => $this->bo->fakebase.'/'.$group_array['account_name'],'relatives'	=> array(RELATIVE_NONE),'checksubdirs' => False,'nofiles' => True));
 
 				$this->files_array[] = $ls_array[0];
+
 				$this->numoffiles++;
-
-				reset($this->readable_groups);
-				while(list($num, $group_array) = each($this->readable_groups))
-				{
-					# If the group doesn't have access to this app, we don't show it
-					/*if(!$this->groups_applications[$group_array['account_name']][$this->bo->appname]['enabled'])
-					{
-						continue;
-					}
-					*/
-
-
-					if(!$this->bo->vfs->file_exists(array('string' => $this->bo->fakebase.'/'.$group_array['account_name'],'relatives'	=> array(RELATIVE_NONE))))
-					{
-						$this->bo->vfs->override_acl = 1;
-						$this->bo->vfs->mkdir(array(
-							'string' => $this->bo->fakebase.'/'.$group_array['account_name'],
-							'relatives' => array(RELATIVE_NONE)
-						));
-
-						// FIXME we just created a fresh group dir so we know there nothing in it so we have to remove all existing content
-						
-						
-						$this->bo->vfs->override_acl = 0;
-
-						$this->bo->vfs->set_attributes(array('string' => $this->bo->fakebase.'/'.$group_array['account_name'],'relatives'	=> array(RELATIVE_NONE),'attributes' => array('owner_id' => $group_array['account_id'],'createdby_id' => $group_array['account_id'])));
-					}
-
-					$ls_array = $this->bo->vfs->ls(array('string' => $this->bo->fakebase.'/'.$group_array['account_name'],'relatives'	=> array(RELATIVE_NONE),'checksubdirs' => False,'nofiles' => True));
-
-					$this->files_array[] = $ls_array[0];
-
-					$this->numoffiles++;
-				}
+			}
+		}
+		else
+		{
+			$ls_array = $this->bo->vfs->ls(array(
+				'string' => $this->path,
+				'relatives'	=> array(RELATIVE_NONE),
+				'checksubdirs' => False,
+				'nofiles'	=> False,
+				'orderby'	=> $this->criteria,
+				'otype'		=> $this->otype,
+				'limit'		=> $this->limit,
+				'offset'	=> $this->offset
+			));
+
+			while(list($num, $file_array) = each($ls_array))
+			{
+				$this->numoffiles++;
+				$this->files_array[] = $file_array;
+			}
+		}
+
+		if(!is_array($this->files_array))
+		{
+			$this->files_array = array();
+		}
+		// end file count
+	}
+	
+	function removedir()
+	{
+		//$toRemove = $this->path ^ $_SESSION['phpgw_info']['filemanager']['user']['sec_key'];
+		$toRemove = $this->path;
+		
+		if ( $this->bo->vfs->rm(array( 'string' => $toRemove, 'relatives' => array (RELATIVE_NONE) )) )
+			echo "True";
+		else
+			echo "False";
+	}
+	
+	function createdir()
+	{
+		if( $this->bo->badchar = $this->bo->bad_chars($this->filename, True, True) )
+		{
+			echo lang('Error:').$this->bo->html_encode(lang('Directory names cannot contain "%1"', $badchar), 1);
+			return;
+		}
+		/* TODO is this right or should it be a single $ ? */
+		if($this->filename[strlen($this->filename)-1] == ' ' || $this->filename[0] == ' ')
+		{
+			echo lang('Error:').lang('Cannot create directory because it begins or ends in a space');
+		}
+		
+		$ls_array = $this->bo->vfs->ls(array(
+			'string'	=> $this->path . '/' . $this->filename,
+			'relatives'	=> array(RELATIVE_NONE),
+			'checksubdirs'	=> False,
+			'nofiles'	=> True
+		));
+
+		$fileinfo = $ls_array[0];
+
+		if($fileinfo['name'])
+		{
+			if($fileinfo['mime_type'] != 'Directory')
+			{
+				echo lang('Error:').lang('%1 already exists as a file',$fileinfo['name']);
 			}
 			else
 			{
-				$ls_array = $this->bo->vfs->ls(array(
-					'string' => $this->path,
-					'relatives'	=> array(RELATIVE_NONE),
-					'checksubdirs' => False,
-					'nofiles'	=> False,
-					'orderby'	=> $this->criteria,
-					'otype'		=> $this->otype,
-					'limit'		=> $this->limit,
-					'offset'	=> $this->offset
-				));
-
-				while(list($num, $file_array) = each($ls_array))
-				{
-					$this->numoffiles++;
-					$this->files_array[] = $file_array;
-				}
-			}
-
-			if(!is_array($this->files_array))
-			{
-				$this->files_array = array();
-			}
-			// end file count
-		}
+				echo lang('Error:').lang('Directory %1 already exists', $fileinfo['name']);
+			}
+		}
+		else
+		{
+			$this->bo->vfs->cd(array('string' => $this->path, 'relatives' => array(RELATIVE_NONE), 'relative' => False));
+			
+			if( $this->bo->vfs->mkdir(array('string' => $this->filename )) )
+			{
+				echo lang('Created directory %1', $this->disppath.'/'.$this->filename);
+			}
+			else
+			{
+				echo lang('Error:').lang('Could not create %1', $this->disppath.'/'.$this->filename);
+			}
+		}
+		echo lang('Directory created');
+	}
+	
+	function getReturnExecuteForm()
+	{
+		$response = $_SESSION['response'];
 		
-		function removedir()
-		{
-			//$toRemove = $this->path ^ $_SESSION['phpgw_info']['filemanager']['user']['sec_key'];
-			$toRemove = $this->path;
-			
-			if ( $this->bo->vfs->rm(array( 'string' => $toRemove, 'relatives' => array (RELATIVE_NONE) )) )
-				echo "True";
-			else
-				echo "False";
-		}
+		unset($_SESSION['response']);
 		
-		function createdir()
-		{
-			if( $this->bo->badchar = $this->bo->bad_chars($this->filename, True, True) )
-			{
-				echo lang('Error:').$this->bo->html_encode(lang('Directory names cannot contain "%1"', $badchar), 1);
-				return;
-			}
-			/* TODO is this right or should it be a single $ ? */
-			if($this->filename[strlen($this->filename)-1] == ' ' || $this->filename[0] == ' ')
-			{
-				echo lang('Error:').lang('Cannot create directory because it begins or ends in a space');
-			}
-			
-			$ls_array = $this->bo->vfs->ls(array(
-				'string'	=> $this->path . '/' . $this->filename,
-				'relatives'	=> array(RELATIVE_NONE),
-				'checksubdirs'	=> False,
-				'nofiles'	=> True
-			));
-
-			$fileinfo = $ls_array[0];
-
-			if($fileinfo['name'])
-			{
-				if($fileinfo['mime_type'] != 'Directory')
-				{
-					echo lang('Error:').lang('%1 already exists as a file',$fileinfo['name']);
-				}
-				else
-				{
-					echo lang('Error:').lang('Directory %1 already exists', $fileinfo['name']);
-				}
-			}
-			else
-			{
-				$this->bo->vfs->cd(array('string' => $this->path, 'relatives' => array(RELATIVE_NONE), 'relative' => False));
-				
-				if( $this->bo->vfs->mkdir(array('string' => $this->filename )) )
-				{
-					echo lang('Created directory %1', $this->disppath.'/'.$this->filename);
-				}
-				else
-				{
-					echo lang('Error:').lang('Could not create %1', $this->disppath.'/'.$this->filename);
-				}
-			}
-			echo lang('Directory created');
-		}
+		echo $response;
+	}
+	
+	function showUploadboxes()
+	{
+		$notify = CreateObject('filemanager.notifications');
 		
-		function getReturnExecuteForm()
-		{
-			$response = $_SESSION['response'];
-			
-			unset($_SESSION['response']);
-			
-			echo $response;
-		}
+		$var = array(
+					'change_upload_boxes' 	=> lang('Show'),				
+					'form_action' 			=> $GLOBALS[phpgw]->link('/filemanager/inc/upload.php'),
+					'emails_to'				=> $notify->EmailsToSend($GLOBALS['phpgw']->preferences->values['email']),
+					'lang_file'				=> lang('File'),
+					'lang_comment'			=> lang('Comment'),
+					'lang_advanced_upload'	=> lang('Advanced Upload'),
+					'lang_upload' 			=> lang('Upload files'),
+					'max_size' 				=> lang('Note: Uploaded is limited to %1MB',( $this->current_config['filemanager_Max_file_size'])),				
+					'path'					=> $this->path
+		);
 		
-		function showUploadboxes()
-		{
-			$var = array(
-						'change_upload_boxes' 	=> lang('Show'),				
-						'form_action' 			=> $GLOBALS[phpgw]->link('/filemanager/inc/upload.php'),
-						'lang_file'				=> lang('File'),
-						'lang_comment'			=> lang('Comment'),
-						'lang_advanced_upload'	=> lang('Advanced Upload'),
-						'lang_upload' 			=> lang('Upload files'),
-						'max_size' 				=> lang('Note: Uploaded is limited to %1MB',( $this->current_config['filemanager_Max_file_size'])),				
-						'path'					=> $this->path
-					);
-			
-			print( serialize($var) );
-			
-		}
-
-		/* create textfile */
-		function createfile()
-		{
-			$this->filename=$this->newfile_or_dir;
-			if($this->filename)
-			{
-				if($badchar = $this->bo->bad_chars($this->filename, True, True))
-				{
-					$this->messages[] = lang('Error:').lang('File names cannot contain "%1"',$badchar);
-
-					$this->fileListing();
-				}
-
-				if($this->bo->vfs->file_exists(array(
-					'string'=> $this->filename,
-					'relatives'	=> array(RELATIVE_ALL)
-				)))
-				{
-					$this->messages[]= lang('Error:').lang('File %1 already exists. Please edit it or delete it first.', $this->filename);
-					$this->fileListing();
-				}
-
-				if($this->bo->vfs->touch(array(
-					'string'	=> $this->filename,
-					'relatives'	=> array(RELATIVE_ALL)
-				)))
-				{
-					$this->edit = 1;
-					$this->numoffiles++;
-					$this->edit();
-				}
-				else
-				{
-					$this->messages[]= lang('Error:').lang('File %1 could not be created.', $this->filename);
-					$this->fileListing();
-				}
-			}
-		}
-
-		# Handle Editing files
-		function edit()
-		{
-			if($this->filename)
-			{
-				if (! $this->vfs_functions->verifyLock($this->path.'/'.$this->filename,RELATIVE_NONE)){
-					$GLOBALS['phpgw']->redirect('/index.php');
-				}
-				$ls_array = $this->bo->vfs->ls(array(
-					'string'        => $this->path.'/'.$this->filename,
-					'relatives'     => array(RELATIVE_NONE),
-					'checksubdirs'  => False,
-					'nofiles'       => True
-				));
-				$this->bo->vfs->touch(array(
-					'string'=> $this->path.'/'.$this->filename,
-					'relatives'     => array(RELATIVE_NONE)
-				));
-
-
-				if($ls_array[0]['mime_type'])
-				{
-					$mime_type = $ls_array[0]['mime_type'];
-				}
-				elseif($this->prefs['viewtextplain'])
-				{
-					$mime_type = 'text/plain';
-				}
-				$editable = array('','text/plain','text/csv','text/html','text/text','message/rfc822');
-
-				if(!in_array($mime_type,$editable)){
-					$this->messages[] = lang('Error:').lang('Impossible to edit this file');
-					$this->readFilesInfo();
-					$this->fileListing();
-					return;
-				}
-			}
-
-			$this->readFilesInfo();
-
-			if ($mime_type == 'text/html')
-				$this->t->set_file(array('filemanager_edit' => 'edit_html.tpl'));
-			else
-				$this->t->set_file(array('filemanager_edit' => 'edit_file.tpl'));
-
-			$this->t->set_block('filemanager_edit','row','row');
-
-
-			$vars[refresh_script] = "<script src='filemanager/js/refresh.js'></script>";
-
-			$vars[preview_content]='';
-			if($this->edit_file)
-			{
-				$this->edit_file_content = stripslashes($this->edit_file_content);
-			}
-
-			if($this->edit_preview_x)
-			{
-				$content = $this->edit_file_content;
-
-				$vars[lang_preview_of]=lang('Preview of %1', $this->path.'/'.$edit_file);
-
-				$vars[preview_content]=nl2br($content);
-			}
-			elseif($this->edit_save_x || $this->edit_save_done_x)
-			{
-				$content = $this->edit_file_content;
-				//die( $content);
-				if($this->bo->vfs->write(array(
-					'string'	=> $this->path.'/'.$this->edit_file,
-					'relatives'	=> array(RELATIVE_NONE),
-					'content'	=> $content
-				)))
-				{
-					$this->messages[]=lang('Saved %1', $this->path.'/'.$this->edit_file);
-
-					if($this->edit_save_done_x)
-					{
-						$this->readFilesInfo();
-						$this->fileListing();
-						exit;
-					}
-				}
-				else
-				{
-					$this->messages[]=lang('Could not save %1', $this->path.'/'.$this->edit_file);
-				}
-			}
-
-			# If we're in preview or save mode, we only show the file
-			# being previewed or saved
-			if($this->edit_file &&($this->filename != $this->edit_file))
-			{
-				continue;
-			}
-
-			if($this->filename && $this->bo->vfs->file_exists(array(
+		print( serialize($var) );
+		
+	}
+
+	/* create textfile */
+	function createfile()
+	{
+		$this->filename=$this->newfile_or_dir;
+		if($this->filename)
+		{
+			if($badchar = $this->bo->bad_chars($this->filename, True, True))
+			{
+				$this->messages[] = lang('Error:').lang('File names cannot contain "%1"',$badchar);
+
+				$this->fileListing();
+			}
+
+			if($this->bo->vfs->file_exists(array(
+				'string'=> $this->filename,
+				'relatives'	=> array(RELATIVE_ALL)
+			)))
+			{
+				$this->messages[]= lang('Error:').lang('File %1 already exists. Please edit it or delete it first.', $this->filename);
+				$this->fileListing();
+			}
+
+			if($this->bo->vfs->touch(array(
 				'string'	=> $this->filename,
 				'relatives'	=> array(RELATIVE_ALL)
 			)))
 			{
-				if($this->edit_file)
+				$this->edit = 1;
+				$this->numoffiles++;
+				$this->edit();
+			}
+			else
+			{
+				$this->messages[]= lang('Error:').lang('File %1 could not be created.', $this->filename);
+				$this->fileListing();
+			}
+		}
+	}
+
+	# Handle Editing files
+	function edit()
+	{
+		if($this->filename)
+		{
+			if (! $this->vfs_functions->verifyLock($this->path.'/'.$this->filename,RELATIVE_NONE)){
+				$GLOBALS['phpgw']->redirect('/index.php');
+			}
+			$ls_array = $this->bo->vfs->ls(array(
+				'string'        => $this->path.'/'.$this->filename,
+				'relatives'     => array(RELATIVE_NONE),
+				'checksubdirs'  => False,
+				'nofiles'       => True
+			));
+			$this->bo->vfs->touch(array(
+				'string'=> $this->path.'/'.$this->filename,
+				'relatives'     => array(RELATIVE_NONE)
+			));
+
+
+			if($ls_array[0]['mime_type'])
+			{
+				$mime_type = $ls_array[0]['mime_type'];
+			}
+			elseif($this->prefs['viewtextplain'])
+			{
+				$mime_type = 'text/plain';
+			}
+			$editable = array('','text/plain','text/csv','text/html','text/text','message/rfc822');
+
+			if(!in_array($mime_type,$editable)){
+				$this->messages[] = lang('Error:').lang('Impossible to edit this file');
+				$this->readFilesInfo();
+				$this->fileListing();
+				return;
+			}
+		}
+
+		$this->readFilesInfo();
+
+		if ($mime_type == 'text/html')
+			$this->t->set_file(array('filemanager_edit' => 'edit_html.tpl'));
+		else
+			$this->t->set_file(array('filemanager_edit' => 'edit_file.tpl'));
+
+		$this->t->set_block('filemanager_edit','row','row');
+
+
+		$vars[refresh_script] = "<script src='filemanager/js/refresh.js'></script>";
+
+		$vars[preview_content]='';
+		if($this->edit_file)
+		{
+			$this->edit_file_content = stripslashes($this->edit_file_content);
+		}
+
+		if($this->edit_preview_x)
+		{
+			$content = $this->edit_file_content;
+
+			$vars[lang_preview_of]=lang('Preview of %1', $this->path.'/'.$edit_file);
+
+			$vars[preview_content]=nl2br($content);
+		}
+		elseif($this->edit_save_x || $this->edit_save_done_x)
+		{
+			$content = $this->edit_file_content;
+			//die( $content);
+			if($this->bo->vfs->write(array(
+				'string'	=> $this->path.'/'.$this->edit_file,
+				'relatives'	=> array(RELATIVE_NONE),
+				'content'	=> $content
+			)))
+			{
+				$this->messages[]=lang('Saved %1', $this->path.'/'.$this->edit_file);
+
+				if($this->edit_save_done_x)
 				{
-					$content = stripslashes($this->edit_file_content);
+					$this->readFilesInfo();
+					$this->fileListing();
+					exit;
 				}
-				else
-				{
-					$content = $this->bo->vfs->read(array('string' => $this->filename));
-				}
-				$vars[form_action]= $GLOBALS['phpgw']->link('/index.php','menuaction=filemanager.uifilemanager.index','path='.$this->path);
-				$vars[edit_file]=$this->filename;
-				# We need to include all of the fileman entries for each file's form,
-				# so we loop through again
-				for($i = 0; $i != $this->numoffiles; $i++)
-				{
-					if($this->filename) $value='value="'.$this->filename.'"';
-					$vars[filemans_hidden]='<input type="hidden" name="filename" '.$value.' />';
-				}
-				$vars[file_content]=$content;
-
-				$vars[buttonPreview]=$this->inputButton('edit_preview','edit_preview',lang('Preview %1', $this->bo->html_encode($this->fileman[0], 1)));
-				$vars[buttonSave]=$this->inputButton('edit_save','save',lang('Save %1', $this->bo->html_encode($this->filename, 1)));
-				$vars[buttonDone]=$this->inputButton('edit_save_done','ok',lang('Save %1, and go back to file listing ', $this->bo->html_encode($this->filename, 1)));
-				$vars[buttonCancel]=$this->inputButton('edit_cancel','cancel',lang('Cancel editing %1 without saving', $this->bo->html_encode($this->filename, 1)));
-
-				if ($mime_type == 'text/html'){
-					$vars[fck_edit] = '<script type="text/javascript" src="filemanager/tp/ckeditor/ckeditor.js"></script>
-						<textarea cols="80" id="edit_file_content" name="edit_file_content" rows="10">'.$content.'</textarea>
+			}
+			else
+			{
+				$this->messages[]=lang('Could not save %1', $this->path.'/'.$this->edit_file);
+			}
+		}
+
+		# If we're in preview or save mode, we only show the file
+		# being previewed or saved
+		if($this->edit_file &&($this->filename != $this->edit_file))
+		{
+			continue;
+		}
+
+		if($this->filename && $this->bo->vfs->file_exists(array(
+			'string'	=> $this->filename,
+			'relatives'	=> array(RELATIVE_ALL)
+		)))
+		{
+			if($this->edit_file)
+			{
+				$content = stripslashes($this->edit_file_content);
+			}
+			else
+			{
+				$content = $this->bo->vfs->read(array('string' => $this->filename));
+			}
+			$vars[form_action]= $GLOBALS['phpgw']->link('/index.php','menuaction=filemanager.uifilemanager.index','path='.$this->path);
+			$vars[edit_file]=$this->filename;
+			# We need to include all of the fileman entries for each file's form,
+			# so we loop through again
+			for($i = 0; $i != $this->numoffiles; $i++)
+			{
+				if($this->filename) $value='value="'.$this->filename.'"';
+				$vars[filemans_hidden]='<input type="hidden" name="filename" '.$value.' />';
+			}
+			$vars[file_content]=$content;
+
+			$vars[buttonPreview]=$this->inputButton('edit_preview','edit_preview',lang('Preview %1', $this->bo->html_encode($this->fileman[0], 1)));
+			$vars[buttonSave]=$this->inputButton('edit_save','save',lang('Save %1', $this->bo->html_encode($this->filename, 1)));
+			$vars[buttonDone]=$this->inputButton('edit_save_done','ok',lang('Save %1, and go back to file listing ', $this->bo->html_encode($this->filename, 1)));
+			$vars[buttonCancel]=$this->inputButton('edit_cancel','cancel',lang('Cancel editing %1 without saving', $this->bo->html_encode($this->filename, 1)));
+
+			if ($mime_type == 'text/html'){
+				$vars[fck_edit] = '<script type="text/javascript" src="filemanager/tp/ckeditor/ckeditor.js"></script>
+					<textarea cols="80" id="edit_file_content" name="edit_file_content" rows="10">'.$content.'</textarea>
 						<script type="text/javascript"> CKEDITOR.replace( \'edit_file_content\',{
 removePlugins : \'elementspath\',
